
{******************************************}
{*                                        *}
{* Example for MGKEYB unit.               *}
{*                                        *}
{* 07-27-95 by Mark Gauthier.             *}
{*                                        *}
{******************************************}

uses crt, mgkeyb;

{ procedure call if Break is press }
procedure BreakCall;far;
begin
  Writeln('Break as been pressed');
end;

{ procedure call if key press }
procedure KeyReceived;far;
var
 key: word;
begin
  if iskeypressed then { Key really press? (Normal) }
  begin
    key := getkey;
    if Key = Keyesc then KeyHookStatus := false; { remove hook }
  end
  else
  begin { Here special key hit... }
    if ispause then writeln('pause');
    if isreboot then writeln('reboot');
    if isprntscr then writeln('prntscr');
  end;
end;

var
 key       : word;
 ch        : char;

begin

  CtrlBreakHook := BreakCall;  { Set Hook Address }
  UseCtrlBreakHook := true;    { activated Ctrl-Break hook }

  HookKeyboard := KeyReceived; { Install Hook on keyboard }
  KeyHookStatus := true;       { activated Keyboard Hook  }

  writeln('Keyboard hook installed: pressed esc to remove hook');
  writeln('prtscr, reboot, pause will be intercept.');
  writeln('each key cause a call to our hook.');

  { Now wait until escape pressed }
  repeat
  until KeyHookStatus = false;

  clrscr;
  clearkeybuffer;
  keycodeput(keyesc);    { store escape into keyboard buffer }
  keycodeput(keypgdown); { store escape into keyboard buffer }
  writeln('Number of keys transfer = ',keystringput('Mglibpas'));

  key := getkey;
  writeln(key, Key = Keyesc);
  key := getkey;
  writeln(key, Key = keypgdown);

  while (keypressed) do write(readkey);

  writeln('Extended keyboard = ',iskeybextend);

  {printscreen;}

  clrscr;
  writeln('test your special keys: scroll, num, alt, etc. (esc quit)');

  repeat
    if scrolllockdown then writeln('scroll down');
    if numlockdown then writeln('numlock down');
    if capslockdown then writeln('caps lock down');
    if altkeydown then writeln('alt key down');
    if inskeydown then writeln('ins key down');
    if ctrlkeydown then writeln('ctrl key down');
    if rightshiftdown then writeln('left shift down');
    if leftshiftdown then writeln('right shift down');
    if iskeypressed then if getkey = keyesc then break;
  until false = true;


  setscrolllock; {Activated scroll lock, num lock, insert, caps lock }
  setnumlock;
  setins;
  setcapslock;

  writeln(' is caps lock on   ? ',capslockactive);
  writeln(' is scroll lock on ? ',scrollockactive);
  writeln(' is num lock on    ? ',numlockactive);
  writeln(' is insert key on  ? ',insactive);

  clearscrolllock;
  clearnumlock;
  clearins;
  clearcapslock;

  writeln(' is caps lock on   ? ',capslockactive);
  writeln(' is scroll lock on ? ',scrollockactive);
  writeln(' is num lock on    ? ',numlockactive);
  writeln(' is insert key on  ? ',insactive);

  keycodeput(keyesc); { store escape into keyboard buffer }
  key := getkey;
  key := 0;
  key := getlastkey;
  writeln('lastkey = ',getlastkey);

  writeln;
  writeln('delay = 5000 (esc to quit loop)');
  setkeydelay (5000);
  repeat
    key := getkey;
    write(key);
  until key = keyesc;

  writeln;
  writeln('delay = 500 (esc to quit loop)');
  setkeydelay (500);
  repeat
    key := getkey;
    write(key);
  until key = keyesc;

  clrscr;
  write('press a key:');
  key := getekey;
  writeln;
  writeln('extended keyboard get key = ',key);

  writeln('keyboard disable');
  keyboarddisable;

  for key := 5000 downto 0 do
  begin
    gotoxy(1,wherey);
    write(key,'          ');
    if iskeypressed then
    begin
      key := getekey;
      writeln('key pressed = ',key);
    end;
  end;

  writeln;
  writeln;
  writeln('keyboard enable');
  keyboardenable;


  writeln;
  writeln('buffer cleread, press a key:');
  key := freshkey;

end.
