
{******************************************}
{*                                        *}
{* Example for MGMISC unit.               *}
{*                                        *}
{* 07-27-95 by Mark Gauthier.             *}
{*                                        *}
{******************************************}

{$M $4000,0,0 }   { 16K stack, no heap }

uses mgmisc;

var
  s  : string;

begin


    writeln('PSP segment = ',getpsp);

    writeln('dos break status = ',GetDosBreakStatus);
    SetDosBreakStatus(false);

    writeln('com1 base = ',Bios0040.combase[1]);
    writeln('memory size = ',Bios0040.memorysize);
    writeln('print screen status = ',Bios0050.prnscreenstatus);

    {function getintvec(intnum:byte):pointer;
    procedure setintvec(intnum:byte; procaddr:pointer);}

    { x = inportb($60); same as TP x = port[$60] }
    { outportb($60, 0); sane as TO port[$60] = 0 }

    writeln('Program name = ',getprgname);
    writeln('Program path = ',getprgpath);

    { Convert number to error string value }
    writeln(getdoserrormsg (02));
    writeln(getdoserrormsg (42));

    if isenvvar ('PATH', s) then
    begin
      writeln('PATH =',s);
      changeenvvar ('PATH','C:\');
    end;

    if isenvvar ('PATH', s) then writeln('PATH=',s);

    setturbo (false);

    { farjump ($ffff,0);
      jump at $FFFF:0000 -> reboot }

    writeln('Dos version = ',hi(dosversion),'.',lo(dosversion));
    delayms(1000);

    {warmboot;
    coldboot;}

end.



